#include <stdio.h>

#define FAST_CRC16
//#define SLOW_CRC16

extern const unsigned short ielftool_checksum;

const unsigned char  checksum_start    @ "checksum_start_mark" = 0;
const unsigned char  checksum_end[4]   @ "checksum_end_mark" = {0,0,0,0xEE}; // The last byte is the actual "checksum area end mark"

extern unsigned short slow_crc16(unsigned short, const unsigned char *, unsigned long);
extern unsigned short fast_crc16(unsigned short, const unsigned char *, unsigned long);

int main(void)
{
    unsigned short sum = 0;

#ifdef SLOW_CRC16
    const int zero=0;

    sum = slow_crc16(sum, &checksum_start, (unsigned long) (&checksum_end[3] - &checksum_start + 1));
    sum = slow_crc16(sum, (unsigned char *)&zero, 2);
#elif defined FAST_CRC16
    sum = fast_crc16(sum, &checksum_start, (unsigned long) (&checksum_end[3] - &checksum_start + 1));
#endif

    if (sum != ielftool_checksum)
    {
        printf("Checksum failed: from 0x%hX with this number of bytes 0x%hX \n",
        &checksum_start, (unsigned long) (&checksum_end[3] - &checksum_start + 1));

        printf("Checksum failed: 0x%hX (counted) vs 0x%hX (from ielftool)\n", sum, ielftool_checksum);
    }
    else
    {
        printf("***Checksum 0x%hX is correct!***\n", ielftool_checksum);
    }
}
